;
; AutoIt Version: 3.0
; Language:       English
; Platform:       Win9x/NT
; Author: Jos van der Zande
; Email : jdeb@autoitscript.com
;
; Script Function:
; Store this script in the Helpfile directory where the project file is stored.
; It assumes that the Include directory is a subdir of directory defined in the registry key: "HKEY_LOCAL_MACHINE\SOFTWARE\AutoIt v3\AutoIt","Installdir"
; It will read all *.au3 files in this include directory and create the \html\libfunctions.htm.
; It wil also create one description file per ???.au3 it finds. this will be stored in \html\libfunctions\????.htm.
; All descriptions which are specified in the ???.AU3 are copied into this description htm file and
; references are created to these in the \html\libfunctions.htm.
; ******************************************************
; Read all Include functions and generate helpfile
; ******************************************************
; remove old file that contains a list of userfunctions
; Generate the index File

#include "..\..\_build\include\MiscLib.au3"
#include "..\..\_build\include\OutputLib.au3"
#include <Constants.au3>

Opt("TrayIconDebug", 1)

OnAutoItExitRegister("OnQuit") ; ### When run in standalone
_OutputWindowCreate() ; ### When run in standalone

FileChangeDir(@ScriptDir)

; to be used for passing the /RegenAll
Local $sCmd1 = ""
If $CmdLine[0] Then $sCmd1 = $CmdLine[1]

_OutputBuildWrite("Generate HTM files for all changed UDFs" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' ..\..\_build\include\Gen_txt2Htm.au3 /UDFs ' & $sCmd1)

Local $sHELPFILEDIR = @ScriptDir ; specify the root of the helpfiles
DirCreate($sHELPFILEDIR & "\html\libfunctions")
DirCreate($sHELPFILEDIR & "\html\managements")

_OutputBuildWrite("Generate Reference HTM files for UDFs" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' ..\..\_build\include\Gen_RefPages.au3 /UDFs')

_OutputBuildWrite("Creating the index and TOC entries for all User defined functions" & @CRLF)
Main()

_OutputBuildWrite("Generate Management HTM files for UDFs" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' ..\..\_build\include\Gen_MgtPages.au3 /UDFs')

Exit

Func OnQuit()
	_OutputWaitClosed() ; ### When run in standalone
EndFunc   ;==>OnQuit

Func Main()
	;
	; **********************************************************
	; create the Index/TOC with all UDF functions
	; **********************************************************
	;

	Local $hFO_TOC_HND = FileOpen("UDFs3 TOC.hhc", BitOR($FO_OVERWRITE_CREATE, $FO_UTF8))
	FileWriteLine($hFO_TOC_HND, '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">')
	FileWriteLine($hFO_TOC_HND, '<HTML>')
	FileWriteLine($hFO_TOC_HND, '<HEAD>')
	FileWriteLine($hFO_TOC_HND, '<meta name="GENERATOR" content="Microsoft&reg; HTML Help Workshop 4.1">')
	FileWriteLine($hFO_TOC_HND, '<!-- Sitemap 1.0 -->')
	FileWriteLine($hFO_TOC_HND, '</HEAD><BODY>')
	FileWriteLine($hFO_TOC_HND, '<OBJECT type="text/site properties">')
	FileWriteLine($hFO_TOC_HND, '<param name="Window Styles" value="0x800025">')
	FileWriteLine($hFO_TOC_HND, '<param name="ImageType" value="Folder">')
	FileWriteLine($hFO_TOC_HND, '</OBJECT>')
	FileWriteLine($hFO_TOC_HND, '<UL>')
	FileWriteLine($hFO_TOC_HND, '<LI> <OBJECT type="text/sitemap">')
	FileWriteLine($hFO_TOC_HND, '<param name="Name" value="User Defined Functions Reference">')
	FileWriteLine($hFO_TOC_HND, '<param name="Local" value="html\libfunctions.htm">')
	FileWriteLine($hFO_TOC_HND, '</OBJECT>')
	FileWriteLine($hFO_TOC_HND, '<UL>')
	FileWriteLine($hFO_TOC_HND, '<LI> <OBJECT type="text/sitemap">')
	FileWriteLine($hFO_TOC_HND, '<param name="Name" value="User Defined Function Notes">')
	FileWriteLine($hFO_TOC_HND, '<param name="Local" value="html\libfunction_notes.htm">')
	FileWriteLine($hFO_TOC_HND, '</OBJECT>')

	Local $hFO_INDEX_HND = FileOpen("UDFs3 Index.hhk", BitOR($FO_OVERWRITE_CREATE, $FO_UTF8))
	FileWriteLine($hFO_INDEX_HND, '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">')
	FileWriteLine($hFO_INDEX_HND, '<HTML>')
	FileWriteLine($hFO_INDEX_HND, '<HEAD>')
	FileWriteLine($hFO_INDEX_HND, '<meta name="GENERATOR" content="Microsoft&reg; HTML Help Workshop 4.1">')
	FileWriteLine($hFO_INDEX_HND, '<!-- Sitemap 1.0 -->')
	FileWriteLine($hFO_INDEX_HND, '</HEAD><BODY>')
	FileWriteLine($hFO_INDEX_HND, '<UL>')
	FileWriteLine($hFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
	FileWriteLine($hFO_INDEX_HND, '<param name="Name" value="User Defined Functions Reference">')
	FileWriteLine($hFO_INDEX_HND, '<param name="Local" value="html\libfunctions.htm">')
	FileWriteLine($hFO_INDEX_HND, '</OBJECT>')
	FileWriteLine($hFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
	FileWriteLine($hFO_INDEX_HND, '<param name="Name" value="User Defined Function Notes">')
	FileWriteLine($hFO_INDEX_HND, '<param name="Local" value="html\libfunction_notes.htm">')
	FileWriteLine($hFO_INDEX_HND, '</OBJECT>')
	FileWriteLine($hFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
	FileWriteLine($hFO_INDEX_HND, '<param name="Name" value="UDFs Constants include files">')
	FileWriteLine($hFO_INDEX_HND, '<param name="Local" value="html\libfunction_constants.htm">')
	FileWriteLine($hFO_INDEX_HND, '</OBJECT>')

	FileDelete(@ScriptDir & "\genindex.log")

	Local $hFI_DIR_HND = FileOpen($sHELPFILEDIR & "\txt2htm\txtlibfunctions\Categories.toc")
	; Check if file opened for reading OK
	If $hFI_DIR_HND = -1 Then
		MsgBox($MB_SYSTEMMODAL, "Error", "Unable to open:" & $sHELPFILEDIR & "\txt2htm\txtlibfunctions\Categories.toc")
		Exit
	EndIf

	; write the top of the page of the userfunctions page
	Local $sSAVE_CATEGORY = "", $sSAVE_SUBCATEGORY = "", $sSAVE_SUBSUBCATEGORY = ""
	Local $sFLINE, $sFTOC, $sFSUBTOC, $sFSUBSUBTOC, $sFNAME, $iSplit, $sFSUBTOCPRE
	While 1
		; get filename from include subdir
		$sFLINE = FileReadLine($hFI_DIR_HND)
		If @error = -1 Then
			ExitLoop
		EndIf
		$sFLINE = StringReplace($sFLINE, "&", "&amp;")
		$sFTOC = StringLeft($sFLINE, StringInStr($sFLINE, "|", $STR_NOCASESENSEBASIC, -1) - 1)
		$iSplit = StringInStr($sFTOC, " Reference")
		If $iSplit Then
			$sFSUBTOCPRE = StringLeft($sFTOC, $iSplit)
		Else
			$sFSUBTOCPRE = ""
		EndIf
		$iSplit = StringInStr($sFTOC, "|")
		If $iSplit Then
			$sFSUBTOC = StringTrimLeft($sFTOC, $iSplit)
			$sFTOC = StringLeft($sFTOC, $iSplit - 1)
			$iSplit = StringInStr($sFSUBTOC, "|")
			If $iSplit Then
				$sFSUBSUBTOC = StringTrimLeft($sFSUBTOC, $iSplit)
				$sFSUBTOC = StringLeft($sFSUBTOC, $iSplit - 1)
			Else
				$sFSUBSUBTOC = ""
			EndIf
		Else
			$sFSUBTOC = ""
			$sFSUBSUBTOC = ""
		EndIf
		$sFNAME = StringTrimLeft($sFLINE, StringInStr($sFLINE, "|", $STR_NOCASESENSEBASIC, -1))
		If StringInStr($sFNAME, ":") Then
			$sFNAME = StringSplit($sFNAME, ":")
			; $FAU3 = $sFNAME[1]
			$sFNAME = $sFNAME[2]
		EndIf
		;;ShowMenu(" *** " & $sFTOC & " -> " & $sFNAME, 2)
		; close previous category
		If $sSAVE_CATEGORY <> $sFTOC Then
			; close previous category
			If $sSAVE_SUBSUBCATEGORY <> "" Then
				FileWriteLine($hFO_TOC_HND, "</UL>")
				$sSAVE_SUBSUBCATEGORY = ""
			EndIf
			; close previous category
			If $sSAVE_SUBCATEGORY <> "" Then
				FileWriteLine($hFO_TOC_HND, "</UL>")
				$sSAVE_SUBCATEGORY = ""
			EndIf
			If $sSAVE_CATEGORY <> "" Then
				FileWriteLine($hFO_TOC_HND, "</UL>")
				$sSAVE_CATEGORY = ""
			EndIf
			$sSAVE_CATEGORY = $sFTOC
			FileWriteLine($hFO_TOC_HND, '<LI> <OBJECT type="text/sitemap">')
			FileWriteLine($hFO_TOC_HND, '<param name="Name" value="' & $sFTOC & '">')
			FileWriteLine($hFO_TOC_HND, '<param name="Local" value="html\managements\' & StringReplace($sFTOC, "&amp;", "&") & '.htm">')
			FileWriteLine($hFO_TOC_HND, '</OBJECT>')
			FileWriteLine($hFO_TOC_HND, "<UL>")
		EndIf
		; close previous subsub category
		If $sSAVE_SUBSUBCATEGORY <> $sFSUBSUBTOC And $sSAVE_SUBSUBCATEGORY <> "" Then
			FileWriteLine($hFO_TOC_HND, "</UL>")
			$sSAVE_SUBSUBCATEGORY = ""
		EndIf
		; close previous sub category
		If $sSAVE_SUBCATEGORY <> $sFSUBTOC And $sSAVE_SUBCATEGORY <> "" Then
			FileWriteLine($hFO_TOC_HND, "</UL>")
			$sSAVE_SUBCATEGORY = ""
		EndIf
		If $sSAVE_SUBCATEGORY <> $sFSUBTOC Then
			$sSAVE_SUBCATEGORY = $sFSUBTOC
			FileWriteLine($hFO_TOC_HND, '<LI> <OBJECT type="text/sitemap">')
			FileWriteLine($hFO_TOC_HND, '<param name="Name" value="' & $sFSUBTOC & '">')
			FileWriteLine($hFO_TOC_HND, '<param name="Local" value="html\managements\' & StringReplace($sFSUBTOCPRE & $sFSUBTOC, "&amp;", "&") & '.htm">')
			FileWriteLine($hFO_TOC_HND, '</OBJECT>')
			FileWriteLine($hFO_TOC_HND, "<UL>")
		EndIf
		If $sSAVE_SUBSUBCATEGORY <> $sFSUBSUBTOC Then
			$sSAVE_SUBSUBCATEGORY = $sFSUBSUBTOC
			FileWriteLine($hFO_TOC_HND, '<LI> <OBJECT type="text/sitemap">')
			FileWriteLine($hFO_TOC_HND, '<param name="Name" value="' & $sFSUBSUBTOC & '">')
			FileWriteLine($hFO_TOC_HND, '<param name="Local" value="html\managements\' & StringReplace($sFSUBTOCPRE & $sFSUBSUBTOC, "&amp;", "&") & '.htm">')
			FileWriteLine($hFO_TOC_HND, '</OBJECT>')
			FileWriteLine($hFO_TOC_HND, "<UL>")
		EndIf
		If Not FileExists('html\libfunctions\' & $sFNAME & '.htm') Then
			_OutputBuildWrite("File not found...skipped :" & 'html\libfunctions\' & $sFNAME & '.htm' & @CRLF)
			WriteLog("File not found...skipped :" & 'html\libfunctions\' & $sFNAME & '.htm')
		Else
			; write TOC entry
			FileWriteLine($hFO_TOC_HND, '<LI> <OBJECT type="text/sitemap">')
			FileWriteLine($hFO_TOC_HND, '   <param name="Name" value="' & $sFNAME & '">')
			FileWriteLine($hFO_TOC_HND, '   <param name="Local" value="html\libfunctions\' & $sFNAME & '.htm">')
			FileWriteLine($hFO_TOC_HND, '   </OBJECT>')
			; write index entry
			FileWriteLine($hFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
			FileWriteLine($hFO_INDEX_HND, '   <param name="Name" value="' & $sFNAME & '">')
			FileWriteLine($hFO_INDEX_HND, '   <param name="Local" value="html\libfunctions\' & $sFNAME & '.htm">')
			FileWriteLine($hFO_INDEX_HND, '   </OBJECT>')
		EndIf
	WEnd
	; close off the Category FileChangeDir and end the TOC UL for the last include file
	If $sSAVE_SUBCATEGORY <> "" Then FileWriteLine($hFO_TOC_HND, "</UL>")
	If $sSAVE_SUBSUBCATEGORY <> "" Then FileWriteLine($hFO_TOC_HND, "</UL>")
	FileWriteLine($hFO_TOC_HND, "</UL>")

	; end the TOC UL for UDF's
	FileWriteLine($hFO_TOC_HND, "</UL>")
	FileWriteLine($hFO_TOC_HND, "</UL>")
	FileWriteLine($hFO_TOC_HND, '</BODY></HTML>')
	FileClose($hFO_TOC_HND)
	;
	FileWriteLine($hFO_INDEX_HND, '</UL>')
	FileWriteLine($hFO_INDEX_HND, '</BODY></HTML>')
	FileClose($hFO_INDEX_HND)

	FileClose($hFI_DIR_HND)
EndFunc   ;==>Main

Func WriteLog($sLMSG)
	FileWriteLine(@ScriptDir & "\genindex.log", $sLMSG)
EndFunc   ;==>WriteLog
